summaryrefslogtreecommitdiffabout
authorMichael Krelin <hacker@klever.net>2016-01-07 17:31:31 (UTC)
committer Michael Krelin <hacker@klever.net>2016-01-07 17:31:31 (UTC)
commit5980d4a6d0f40119a633020146b861a805b108c8 (patch) (side-by-side diff)
tree5418575f9c072d57fe7afb38e26525653e41e262
parent8366ce3996a539918b7a3e04fa6b5d9cdce580ad (diff)
downloadredelta-5980d4a6d0f40119a633020146b861a805b108c8.zip
redelta-5980d4a6d0f40119a633020146b861a805b108c8.tar.gz
redelta-5980d4a6d0f40119a633020146b861a805b108c8.tar.bz2
feet
Diffstat (more/less context) (ignore whitespace changes)
-rw-r--r--delta.jscad44
1 files changed, 43 insertions, 1 deletions
diff --git a/delta.jscad b/delta.jscad
index b718fd4..fa33a0d 100644
--- a/delta.jscad
+++ b/delta.jscad
@@ -22,24 +22,32 @@ var CONFIG = {
sr: 220/2-4.5, // radius of the screwholes circle
h: 3+1.5 // thickness (including insulation)
},
glass: {
r: 195/2, // glass radius
h: 3 // glass thickness
},
duet: {
pcb_size: { x: 124, y: 100, z: 1 },
hole_spacing: { x: 115, y: 92 },
h: 30
},
+ foot: {
+ d: 20*Math.sqrt(2), h: 30,
+ bolt: { d:5, l: 19, hd: 10 },
+ margin: 2.5,
+ nut: { d: 8.6 /* TODO: */, h: 3.5 },
+ shell: 4,
+ zscalefactor: 1.6
+ },
hotend: {
h: 62.4, // full assembly height
groove: { d:12, h:6 }, // grove diameter and height
ungroove: { d:16, above:3.7, below: 3+4 }
},
effector: {
h: 6,
o: 20, // offset to the rod mounts line
rods_apart: 40,
cone: { shell: 1, angle: Math.PI/6 },
rodend: {
joint_w: 7, // thickness of the joint
@@ -73,25 +81,26 @@ var CONFIG = {
width: 3, height: 5+1, length: 6
},
fanholder: {
r: 30,
screw: { d: 3, m: 2.5/*margin*/ },
w: 3
}
},
nut: { h: 2.3, w: 5.5 },
color: {
extrusion: [0.8, 0.8, 0.8, 0.8],
pcb: [ 0, 0.3, 0.2, 0.8 ],
- bulk: [ .9, .9, .9, .2 ]
+ bulk: [ .9, .9, .9, .2 ],
+ parts: [ 0, 0.8, 0, 0.9 ]
}
};
var CD = {
base: (function(){
var rv = {};
rv.circumscription_r =
CONFIG.base.sl/2/Math.cos(Math.PI/6);
rv.outer_inscription_r =
Math.sqrt(Math.pow(rv.circumscription_r,2)-
Math.pow(CONFIG.base.sl/2,2));
rv.mid_inscription_r =
@@ -575,40 +584,73 @@ function duet() {
}).subtract(holes).setColor(CONFIG.color.pcb).union(
CSG.cube({
corner1: [-C.pcb_size.x/2,-C.hole_spacing.y/2+3,C.pcb_size.z],
corner2: [ C.pcb_size.x/2, C.hole_spacing.y/2-3,C.h]
}).setColor(CONFIG.color.bulk)
);
rv.properties.holes = pholes;
rv.properties.P = new CSG.Connector([0,0,0],[0,0,1],[1,0,0]);
rv.properties.vitamin = true;
return rv;
}
+function foot() {
+ var F = CONFIG.foot;
+ var br = F.bolt.hd/2+F.margin;
+ var bh = F.zscalefactor*Math.sqrt(Math.pow(F.d/2,2)-Math.pow(br,2));
+ var th = F.h-bh;
+ var r = 2*F.d;
+ var rv = CSG.sphere({ // botom contorted sphere
+ center: [0,0,0], radius: F.d/2, resolution: r
+ }).scale([1,1,F.zscalefactor]).translate([0,0,bh]).union(CSG.cylinder({ // top hat
+ start: [0,0,bh], end: [0,0,F.h], radius: F.d/2, resolution: r
+ })).intersect(CSG.cylinder({ // cut off excess
+ start: [0,0,0], end: [0,0,F.h], radius: F.d
+ })).subtract([
+ CSG.cylinder({ // bolt hole
+ start: [0,0,-1], end: [0,0,F.h+1], radius: F.bolt.d/2+PRINT.slide_tolerance
+ }), CSG.cylinder({ // nut hole
+ start: [0,0,F.h-F.nut.h-PRINT.play_tolerance],
+ end: [0,0,F.h],
+ radius: F.nut.d/2+PRINT.slide_tolerance, resolution: 6
+ }), CSG.cylinder({ // bolthead/washer hole
+ start: [0,0,-1], end: [0,0,F.h-F.nut.h-PRINT.play_tolerance-F.shell],
+ radius: F.bolt.hd/2+PRINT.play_tolerance
+ })
+ ]).union(CSG.cylinder({ // bridging patch
+ start: [0,0,F.h-F.nut.h-PRINT.play_tolerance-PRINT.layer_height],
+ end: [0,0,F.h-F.nut.h-PRINT.play_tolerance],
+ radius: F.nut.d/2
+ }));
+ rv.properties.P = new CSG.Connector([0,0,F.h],[0,0,-1],[1,0,0]);
+ return rv.setColor(CONFIG.color.parts);
+}
+
function refaxes(o) {
if(!o) o = {};
var l = o.l||20, g = o.g||0.7;
return union([
CSG.cylinder({start:[0,0,0],end:[l,0,0]}).setColor([1,0,0,g]),
CSG.cylinder({start:[0,0,0],end:[0,l,0]}).setColor([0,1,0,g]),
CSG.cylinder({start:[0,0,0],end:[0,0,l]}).setColor([0,0,1,g])
]);
}
function P(x) {
return x.connectTo(x.properties.P,new CSG.Connector([0,0,0],[0,0,1],[1,0,0]), false, 0);
}
var PARTS = {
wip: function(params) {
+ return foot();
return union(base_extrusions(),column_extrusions(),duet());
}
};
function main(params) {
var part = params.part && PARTS[params.part];
if(!part) return refaxes();
var rv = P(part(params));
if(!params.print) rv = rv.union(refaxes());
return rv;
}